unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Math;

type
    TRek = packed record
         Nazwa: String[42];
         Koszt: String[50];
         Kolor: Byte;
         Tekst: packed array[1..800] of Char;
         TekstN: Word;
         Typ: String[36];
         Param: String[8];
         Rzadkosc: Byte;
         Edycje: array[1..30] of Byte;
         end;

    TPlikBazy = file of TRek;

  TForm1 = class(TForm)
    Cd: TLabeledEdit;
    Rozpocznij: TButton;
    procedure RozpocznijClick(Sender: TObject);
  end;

var
Form1: TForm1;
Reki: array of TRek;
Steki: array of Boolean;

{$R Unit1.dfm}

implementation

procedure TForm1.RozpocznijClick(Sender: TObject);
var
tf,edy: TextFile;
f: TPlikBazy;
w: TRek;
s,t: String;
sk: Byte;
a,i: Word;
pu: Integer;
gu: ShortInt;
begin
AssignFile(edy,'edycje.ini');
Reset(edy);
AssignFile(f,'baza');
Rewrite(f);
pu:=0;
gu:=-1;
while not Eof(edy) do begin
      ReadLn(edy,s);
      Inc(gu);
      if s='' then break;
      Delete(s,1,Pos('  ',s)+1);
      s:='oracle/'+Trim(s)+'.txt';
      Cd.Text:=s;
      Cd.Refresh;
      if FileExists(s) then begin
         AssignFile(tf,s);
         Reset(tf);

         ReadLn(tf,s);
         s:=Trim(s);
repeat
for a:=1 to 42 do w.Nazwa[a]:=#0;
for a:=1 to 50 do w.Koszt[a]:=#0;
for a:=1 to 800 do w.Tekst[a]:=#0;
for a:=1 to 36 do w.Typ[a]:=#0;
for a:=1 to 8 do w.Param[a]:=#0;
for a:=1 to 30 do w.Edycje[a]:=0;
w.Kolor:=0;
w.TekstN:=0;
w.Rzadkosc:=0;
w.Param:='';

s:=StringReplace(s,' // ','/',[]);
s:=StringReplace(s,'',#39,[rfReplaceAll]);
w.Nazwa:=s;
ReadLn(tf,s);
s:=Trim(s);
if Copy(s,1,1)='{' then begin
   for a:=1 to Length(s) do begin
       sk:=w.Kolor;
       if s[a]='U' then w.Kolor:=1;
       if s[a]='B' then w.Kolor:=2;
       if s[a]='R' then w.Kolor:=3;
       if s[a]='G' then w.Kolor:=4;
       if s[a]='W' then w.Kolor:=5;
       if (sk<>w.Kolor) and (sk>0) then begin
          w.Kolor:=8;
          break;
          end;
       end;
   if w.Kolor=0 then w.Kolor:=7;
   s:=StringReplace(s,'10','D',[rfReplaceAll]);
   s:=StringReplace(s,' // ','/',[]);
   w.Koszt:=s;
   ReadLn(tf,s);
   s:=Trim(s);
   end else begin
       w.Koszt:='';
       w.Kolor:=6;
       end;
a:=Pos('--',s);
while a>0 do begin
      Delete(s,a,1);
      s[a]:='';
      a:=Pos('--',s);
      end;
if Pos(' // ',s)>0 then s:=Copy(s,1,Pos(' // ',s)-1);

if Copy(s,1,18)='Legendary Creature' then begin
   Delete(s,1,10);
   s:=s+' Legend';
   end;
w.Typ:=s;
if (Copy(s,1,8)='Creature') or (Copy(s,1,17)='Artifact Creature') then begin
   ReadLn(tf,s);
   s:=Trim(s);
   w.Param:=s;
   end;
t:='';
ReadLn(tf,s);
s:=Trim(s);
while s<>'' do begin
      if t<>'' then t:=t+#13#10;
      t:=t+s;
      ReadLn(tf,s);
      s:=Trim(s);
      end;
a:=Pos('[',t);
while a>0 do begin
      t[a]:='{';
      a:=Pos('[',t);
      end;
a:=Pos(']',t);
while a>0 do begin
      t[a]:='}';
      a:=Pos(']',t);
      end;
t:=StringReplace(t,'--','',[rfReplaceAll]);
t:=StringReplace(t,' // ',#13#10'(or)'#13#10,[rfReplaceAll]);
t:=StringReplace(t,'{10}','{d}',[rfReplaceAll]);
t:=StringReplace(t,'',#39,[rfReplaceAll]);
for a:=1 to Length(t) do if t[a]='{' then begin
    t[a+1]:=LowerCase(t[a+1])[1];
    i:=a+2;
    while i<=Length(t) do begin
          if t[i] in ['0'..'9'] then begin
             Insert('}{',t,i);
             Inc(i,2);
             end else break;
          Inc(i);
          end;
    end;
for a:=1 to Length(t) do w.Tekst[a]:=t[a];
w.TekstN:=Length(t);
w.Edycje[1]:=gu+1;
{a:=1;
if Length(Reki)>0 then for i:=0 to High(Reki) do if Reki[i].Nazwa=w.Nazwa then begin
   a:=0;
   break;
   end;
if a>0 then begin}
   Inc(pu);
   while pu>Length(Reki) do SetLength(Reki,Length(Reki)+100);
   Reki[pu-1]:=w;
   //end;

repeat
      ReadLn(tf,s);
      s:=Trim(s);
      until (s<>'') or Eof(tf);
until Eof(tf);

              CloseFile(tf);
              end;
          end;

SetLength(Reki,pu);
SetLength(Steki,Length(Reki));
for i:=0 to High(Reki) do Steki[i]:=True;
repeat
    pu:=-1;
    for a:=0 to High(Reki) do if Steki[a] then begin
        if (pu<0) or (LowerCase(Reki[a].Nazwa)<LowerCase(s)) then begin
           pu:=a;
           s:=Reki[a].Nazwa;
           end;
        end;
    if pu>=0 then begin
       for a:=0 to High(Reki) do if s=Reki[a].Nazwa then begin
           if w.Nazwa=s then begin
              for i:=1 to 31 do if w.Edycje[i]=0 then begin
                  w.Edycje[i]:=Reki[a].Edycje[1];
                  break;
                  end;
              end else w:=Reki[a];
           Steki[a]:=False;
           end;
       Write(f,w);
       end;
    until pu<0;
CloseFile(f);
CloseFile(edy);
MessageDlg('Operacja zostaa ukoczona',mtInformation,[mbOk,mbYes,mbNo,mbRetry,mbCancel,mbIgnore,mbHelp,mbAll,mbYesToAll,mbNoToAll],0);
end;

end.
