unit Unit2;

interface

uses
  Windows, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TFBysz = class(TForm)
    ENazwa: TEdit;
    Label2: TLabel;
    CbRodzaj: TComboBox;
    Label3: TLabel;
    CbPodtyp: TComboBox;
    Label4: TLabel;
    GroupBox1: TGroupBox;
    CzU: TCheckBox;
    CzB: TCheckBox;
    CzR: TCheckBox;
    CzG: TCheckBox;
    CzW: TCheckBox;
    Label1: TLabel;
    ETekst: TMemo;
    Button1: TButton;
    CzA: TCheckBox;
    CzL: TCheckBox;
    CzM: TCheckBox;
    GroupBox2: TGroupBox;
    Label6: TLabel;
    EK1: TEdit;
    Label7: TLabel;
    EK2: TEdit;
    CzCase: TCheckBox;
    GroupBox4: TGroupBox;
    Label5: TLabel;
    Label8: TLabel;
    StS1: TEdit;
    StS2: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    StW1: TEdit;
    Label12: TLabel;
    StW2: TEdit;
    Label13: TLabel;
    cbEdycja: TComboBox;
    procedure CbRodzajChange(Sender: TObject);
    procedure CbPodtypChange(Sender: TObject);
    procedure ENazwaChange(Sender: TObject);
    procedure EK1Change(Sender: TObject);
    procedure EK1KeyPress(Sender: TObject; var Key: Char);
    procedure cbEdycjaChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FBysz: TFBysz;

implementation

{$R *.dfm}

uses UBaza, Typy;

procedure TFBysz.CbRodzajChange(Sender: TObject);
var
a: Integer;
begin
a:=CbRodzaj.ItemIndex;
if a=0 then CbRodzaj.Color:=clBtnFace else CbRodzaj.Color:=clWindow;
CbPodtyp.Color:=clBtnFace;
if a=0 then with CbPodtyp do begin
   Items.Text:='n/a';
   ItemIndex:=0;
   CbPodtyp.Enabled:=False;
   exit;
   end;
CbPodtyp.Items.Assign(cTyp[a]);
CbPodtyp.ItemIndex:=0;
CbPodtyp.Enabled:=True;
end;

procedure TFBysz.CbPodtypChange(Sender: TObject);
begin
if CbPodtyp.ItemIndex=0 then CbPodtyp.Color:=clBtnFace else CbPodtyp.Color:=clWindow;
end;

procedure TFBysz.ENazwaChange(Sender: TObject);
begin
if TCustomEdit(Sender).Text='' then TEdit(Sender).Color:=clBtnFace else TEdit(Sender).Color:=clWindow;
end;

procedure TFBysz.EK1Change(Sender: TObject);
var
s: String;
begin
s:=TCustomEdit(Sender).Text;
if s='' then TEdit(Sender).Color:=clBtnFace else TEdit(Sender).Color:=clWindow;
end;

procedure TFBysz.EK1KeyPress(Sender: TObject; var Key: Char);
begin
if not ((Key in ['0'..'9']) or (Key=#8)) then Key:=#0;
end;

procedure TFBysz.cbEdycjaChange(Sender: TObject);
begin
if cbEdycja.ItemIndex=0 then CbEdycja.Color:=clBtnFace else CbEdycja.Color:=clWindow;
end;

procedure TFBysz.FormCreate(Sender: TObject);
var
i: Byte;
begin
for i:=1 to High(EdycPtr) do cbEdycja.Items.Add(_Edycje[EdycPtr[i],0])
end;

end.
