unit Unit3;

interface

uses
  Windows, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, CheckLst, ExtCtrls, Typy, Buttons, Registry, ShlObj;

type
  TFUsta = class(TForm)
    Zaz: TCheckListBox;
    GroupBox1: TGroupBox;
    Panel1: TPanel;
    Rb2_1: TRadioButton;
    Rb2_2: TRadioButton;
    Panel2: TPanel;
    Rb1_1: TRadioButton;
    Rb1_2: TRadioButton;
    Rb1_3: TRadioButton;
    Rb1_4: TRadioButton;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    procedure ZazClickCheck(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FUsta: TFUsta;

implementation

uses Unit1;

{$R *.dfm}

procedure TFUsta.ZazClickCheck(Sender: TObject);
var
i: Integer;
begin
for i:=0 to Length(aktust.Opcje)-1 do aktust.Opcje[i]:=FUsta.Zaz.Checked[i];
end;

procedure TFUsta.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if Rb1_1.Checked then aktust.Sortowanie:=ssNazwa;
if Rb1_2.Checked then aktust.Sortowanie:=ssEdycja;
if Rb1_3.Checked then aktust.Sortowanie:=ssStan;
if Rb1_4.Checked then aktust.Sortowanie:=ssCena;
aktust.Malejaco:=Rb2_2.Checked;
end;

procedure TFUsta.SpeedButton1Click(Sender: TObject);
const
kij = 'PieterSoft.PieterCennik.plik';

plikiroz: array[0..1] of String = (
'mwDeck',
'pcl'
);
var
reg: TRegistry;
s: String;
begin
if MessageDlg('Czy na pewno chcesz powiza wybrany typ plikw z programem?'#13#10#13#10+
'Dwukrotne kliknicie na ikonk pliku bdzie odtd powodowao otworzenie go w PieterCenniku.',
mtConfirmation,[mbYes,mbNo],0)<>mrYes then exit;

s:='\.'+plikiroz[TSpeedButton(Sender).Tag];
reg:=TRegistry.Create;
reg.RootKey:=HKEY_CLASSES_ROOT;
if reg.KeyExists('\'+kij) then reg.DeleteKey('\'+kij);
if not reg.OpenKey('\'+kij,True) then begin
   MessageDlg('Operacja nie powioda si. Wystpi problem w dostpie do Rejestru.',mtError,[mbOK],0);
   exit;
   end;
reg.WriteString('','Plik programu PieterCennik');

reg.OpenKey('shell',True);
reg.OpenKey('open',True);
reg.OpenKey('command',True);
reg.WriteString('','"'+Application.ExeName+'" "%1"');
reg.CloseKey;

if reg.KeyExists(s) then reg.DeleteKey(s);
if not reg.OpenKey(s,True) then begin
   MessageDlg('Operacja nie powioda si. Wystpi problem w dostpie do Rejestru.',mtError,[mbOK],0);
   exit;
   end;
reg.WriteString('',kij);
reg.CloseKey;
reg.Free;

SHChangeNotify(SHCNE_ASSOCCHANGED, SHCNF_IDLIST, nil, nil);

MessageDlg('Operacja powizania rozszerze zostaa pomylnie ukoczona.',mtInformation,[mbOK],0);
end;

procedure TFUsta.SpeedButton3Click(Sender: TObject);
const
kij = 'PieterSoft.PieterCennik.plik';

plikiroz: array[1..2] of String = (
'mwDeck',
'pcl'
);
var
reg: TRegistry;
s,t: String;
a,i: Byte;
begin
if MessageDlg('Czy na pewno chcesz usun powizania plikw z PieterCennikiem?'#13#10#13#10+
'Otwieranie plikw za pomoc dwukrotnego kliknicia nie bdzie ju moliwe.',
mtConfirmation,[mbYes,mbNo],0)<>mrYes then exit;

reg:=TRegistry.Create;
reg.RootKey:=HKEY_CLASSES_ROOT;
a:=0;
for i:=0 to 2 do begin
    if i=0 then s:='\'+kij else s:='\.'+plikiroz[i];
    if reg.KeyExists(s) then begin
       reg.OpenKey(s,False);
       t:=reg.ReadString('');
       reg.CloseKey;
       if (t=kij) or (i=0) then begin
          Inc(a);
          reg.DeleteKey(s);
          end;
       end;
    end;
reg.Free;

if a=0 then MessageDlg('Nie znaleziono adnych powiza plikw PieterCennika.',mtWarning,[mbOK],0) else begin
   SHChangeNotify(SHCNE_ASSOCCHANGED, SHCNF_IDLIST, nil, nil);
   MessageDlg('Powizania plikw zostay pomylnie usunite.',mtInformation,[mbOK],0);
   end;
end;

end.
