unit UBaza;

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms, Printers,
  Dialogs, ExtCtrls, StdCtrls, jpeg, Math, Menus, Buttons, Typy;

type
    //TPoDoImg = ^TImage;

    TPoDoBit = ^TBitmap;

  TFBaza = class(TForm)
    Img: TImage;
    PopupMenu1: TPopupMenu;
    N331: TMenuItem;
    N501: TMenuItem;
    N751: TMenuItem;
    N1001: TMenuItem;
    N1501: TMenuItem;
    N1: TMenuItem;
    RozwiZwi1: TMenuItem;
    BRozw: TSpeedButton;
    ListBox1: TListBox;
    Button1: TButton;
    Button2: TButton;
    BitBtn1: TBitBtn;
    Timer1: TTimer;
    LZnal: TStaticText;
    WydrukKart: TMenuItem;
    PopupMenu2: TPopupMenu;
    D_talia: TMenuItem;
    D_sajd: TMenuItem;
    function Symbol(bg,fg: TColor; wys: Byte; znak: String): TPoDoBit;
    function Wyraz(bg,fg: TColor; wys: Byte; s,f: String): TPoDoBit;
    procedure ExtTekst(x,y,siz,mx,my: Integer; s: String; im: TBitmap);
    function WczytajBaze: Boolean;
    function IDKarty(s: String): Word;
    procedure Mana(a: Word; Podo: TBitmap);
    procedure Rarity(a: Word; Podo: TBitmap);
    procedure CalaKarta(a: SmallInt; Podo: TBitmap);
    procedure BialoNaC(x,y: Word; siz: Byte; font,s: String; im: TBitmap; dopr: Boolean);
    function ZResJPG(a: Byte): TPoDoBit;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ToSaMo;
    //procedure InfoOKarcie(a: Word);
    procedure N331Click(Sender: TObject);
    procedure Resajz;
    procedure FormResize(Sender: TObject);
    procedure BRozwClick(Sender: TObject);
    procedure RozwDal;
    procedure ZresetujSzuk;
    procedure ListBox1Data(Control: TWinControl; Index: Integer;
      var Data: String);
    procedure Button1Click(Sender: TObject);
    procedure Wypisywanko;
    procedure Zaznacz(a: Integer);
    procedure Button2Click(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure TypStworow;
    procedure RozwiZwi1Click(Sender: TObject);
    function CalyKoszt(s: String): Byte;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BitBtn1Click(Sender: TObject);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure FormDestroy(Sender: TObject);
    procedure ListBox1KeyPress(Sender: TObject; var Key: Char);
    procedure Timer1Timer(Sender: TObject);
    procedure IleZnal;
    procedure OpiszEdycje(Numer: Word; Podo: TBitmap);
    procedure WydrukKartClick(Sender: TObject);
    procedure D_taliaClick(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure CalaZwykla(a: Word);
  private
  ttekst: packed array[1..8192] of String;
  bimpa: TBitmap;
  beee: TBitmap;

  public
  aknum: SmallInt;
  skala: Real;
  sskala: Real;
  il: Word;

  end;

var
   FBaza: TFBaza;
   rozw: Boolean;

   Baza: packed array[1..8192] of TRek;
   itemsy: array[1..8192] of Word;
   itemsc: Word;
   topind: Word;

   vres: Boolean = False;

   cTyp: array[1..6] of TStringList;

   szuktekst: String = '';

implementation

uses Unit1, Unit2, Unit8, Unit9, Unit10;

{$R *.dfm}

{$R zasoby.res}

function TFBaza.Symbol(bg,fg: TColor; wys: Byte; znak: String): TPoDoBit;
var
b: TBitmap;
begin
b:=TBitmap.Create;
b.Canvas.Font.Height:=wys;
b.Canvas.Font.Name:='MagicSymbols';
b.Width:=b.Canvas.TextWidth('u');
b.Height:=Round(wys*0.84);
b.Canvas.Brush.Color:=bg;
b.Canvas.FillRect(Rect(0,0,b.Width,b.Height));
b.TransparentMode:=tmFixed;
b.TransparentColor:=bg;
b.Transparent:=True;
b.Canvas.Font.Color:=fg;
b.Canvas.TextOut(0,0,znak);
bimpa.Assign(b);
Result:=@bimpa;
b.Free;
end;

function TFBaza.Wyraz(bg,fg: TColor; wys: Byte; s,f: String): TPoDoBit;
var
b: TBitmap;
begin
b:=TBitmap.Create;
b.Canvas.Font.Height:=wys;
b.Canvas.Font.Name:=f;
//if f=fTimes then b.Canvas.Font.Style:=[fsBold] else b.Canvas.Font.Style:=[];
b.Width:=b.Canvas.TextWidth(s);
b.Height:=b.Canvas.TextHeight(s);
b.Canvas.Brush.Color:=bg;
b.Canvas.FillRect(Rect(0,0,b.Width,b.Height));
b.TransparentMode:=tmFixed;
b.TransparentColor:=bg;
b.Transparent:=True;
b.Canvas.Font.Color:=fg;
b.Canvas.TextOut(0,0,s);
Result:=@Bimpa;
bimpa.Assign(b);
b.Free;
end;

procedure TFBaza.ExtTekst(x,y,siz,mx,my: Integer; s: String; im: TBitmap);
var
i,j,ofs,oy,u: Integer;
kol,bgk,skol: TColor;
b: TBitmap;
t,t2,ss: String;
bool: Boolean;
cal: TBitmap;
label 2,koniec,pocz,ff;
begin
ss:=s;
b:=TBitmap.Create;
cal:=TBitmap.Create;
cal.Width:=mx;
cal.Height:=my;
bgk:=im.Canvas.Pixels[x,y];
cal.TransparentMode:=tmFixed;
cal.TransparentColor:=bgk;
cal.Transparent:=True;
pocz: s:=ss;
cal.Canvas.Brush.Color:=bgk;
cal.Canvas.FillRect(Rect(0,0,mx,my));
ofs:=0;
oy:=0;
if s='' then goto koniec;
2: if s[1]='{' then begin
      j:=0;
      bool:=False;
      for i:=1 to Length(s) do begin
          if s[i]='{' then bool:=True;
          if s[i]='}' then bool:=False;
          if (s[i]<>'{') and (s[i]<>'}') then begin
             if bool then Inc(j) else break;
             end;
          end;
      if ofs+(j*siz*78 div 100)>mx then begin
         ofs:=0;
         Inc(oy,siz);
         if oy+siz>my then begin
            Dec(siz);
            goto pocz;
            end;
         end;
      end;
while s[1]='{' do begin
   t2:=LowerCase(Copy(s,2,Pos('}',s)-2));
   Delete(s,1,Length(t2)+2);
   kol:=clLtGray;
   for u:=1 to Length(t2) do begin
       if u>1 then Inc(ofs,(siz*40 div 100));
       t:=t2[u];

       if t='u' then kol:=$FFCCBB;
       if t='b' then kol:=clDkGray;
       if t='r' then kol:=$7777FF;
       if t='g' then kol:=$00AA00;
       if t='w' then kol:=$AAFFFF;
       if t='d' then t:=#$BA;
       skol:=clBlack;
       if (t<>'/') then cal.Canvas.Draw(ofs,oy,Symbol(bgk,kol,siz,'o')^) else begin
          kol:=clBlack;
          skol:=clWhite;
          end;
       if t='t' then begin
          cal.Canvas.Draw(ofs,oy,Symbol(kol,clBlack,siz,'C')^);
          cal.Canvas.Draw(ofs,oy,Symbol(clBlack,clWhite,siz,'t')^);
       end else cal.Canvas.Draw(ofs,oy,Symbol(kol,skol,siz,t)^);
       end;

   Inc(ofs,(siz*78 div 100));
   if s='' then goto koniec;
   end;
if Pos('{',s)>0 then i:=Pos('{',s)-1 else i:=Length(s);
t:=Copy(s,1,i);
Delete(s,1,i);
while t<>'' do begin
      ff: if Pos(' ',t)>0 then i:=Pos(' ',t) else i:=Length(t);
      t2:=Copy(t,1,i);
      if Copy(t,1,2)=#13#10 then begin
         ofs:=0;
         Inc(oy,(siz*3) div 2);
         if oy+siz>my then begin
            Dec(siz);
            goto pocz;
            end;
         Delete(t,1,2);
         goto ff;
         end;
      if Pos(#13#10,t2)>0 then begin
         i:=Pos(#13#10,t2)-1;
         t2:=Copy(t,1,i);
         end;
      Delete(t,1,i);
      b.Assign(Wyraz(bgk,clBlack,siz,t2,fTimes)^);
      if ofs+b.Width>mx then begin
         ofs:=0;
         Inc(oy,siz);
         if oy+siz>my then begin
            Dec(siz);
            goto pocz;
            end;
         end;
      cal.Canvas.Draw(ofs,oy,b);
      Inc(ofs,b.Width);
      end;
if s<>'' then goto 2;
koniec: oy:=(my-(oy+siz)) div 2;
im.Canvas.Draw(x,y+oy,cal);
b.Free;
cal.Free;
end;

function TFBaza.WczytajBaze: Boolean;
var
f: TPlikBazy;
r: TRek;
begin
SetCurrentDir(deffol);
il:=0;
Result:=False;
aknum:=-1;
if FileExists('baza')=False then exit;
AssignFile(f,'baza');
Reset(f);
repeat
      Read(f,r);
      Inc(il);
      ttekst[il]:=Copy(r.Tekst,1,r.TekstN);
      Baza[il]:=r;
      until Eof(f);
CloseFile(f);
aknum:=0;
bimpa:=TBitmap.Create;
Result:=True;
SetCurrentDir(deffol);
end;

function TFBaza.IDKarty(s: String): Word;
var
i: Integer;
begin
Result:=0;
for i:=1 to il do if SameText(Copy(s,1,Length(Baza[i].Nazwa)),Baza[i].Nazwa) then begin
    Result:=i;
    if SameText(s,Baza[i].Nazwa) then exit;
    end;
end;

procedure TFBaza.Mana(a: Word; Podo: TBitmap);
var
t: String;
n,ff,i: Integer;
sz: Integer;
begin
sz:=Trunc(24*skala);
t:=Baza[a].Koszt;
if t='' then exit;
n:=0;
for i:=1 to Length(t) do if t[i]='{' then Inc(n);
ff:=Length(t)-(3*n);

ff:=Trunc(310*skala)-((n*sz*76+ff*sz*40) div 100);

ExtTekst(ff,Trunc(17*skala),sz,Trunc(410*skala)-ff,sz,t,Podo);
end;

procedure TFBaza.Rarity(a: Word; Podo: TBitmap);
var
bi: TBitmap;
k: TColor;
x,xx,y,yy: Integer;
begin
if Baza[a].Rzadkosc=0 then exit;
bi:=TBitmap.Create;
x:=Trunc(285*skala);
y:=Trunc(255*skala);
k:=Img.Canvas.Pixels[x,y];
bi.Assign(Symbol(k,clWhite,Trunc(22*skala),'o')^);
Podo.Canvas.Draw(x,y,bi);
xx:=bi.Width;
yy:=bi.Height;
bi.Assign(Symbol(clWhite,tRarK[Baza[a].Rzadkosc],Trunc(19*skala),'o')^);
x:=x+((xx-bi.Width) div 2);
y:=y+((yy-bi.Height) div 2);
Podo.Canvas.Draw(x,y,bi);
bi.Free;
end;

procedure TFBaza.CalaKarta(a: SmallInt; Podo: TBitmap);
var
aa: ShortInt;
begin
if aknum<0 then exit;
if (a=0) or ((a=aknum) and (skala=sskala)) then exit;
sskala:=skala;
aknum:=a;
with Podo.Canvas do begin
     Podo.Width:=Trunc(336*skala);
     Podo.Height:=Trunc(468*skala);
     StretchDraw(Rect(0,0,Trunc(336*skala),Trunc(468*skala)),ZResJPG(Baza[a].Kolor)^);
     end;
if Length(ttekst[a])=3 then
ExtTekst(Trunc(130*skala),Trunc(283*skala),Trunc(100*skala),Trunc(150*skala),Trunc(125*skala),ttekst[a],Podo) else
ExtTekst(Trunc(42*skala),Trunc(283*skala),Trunc(20*skala),Trunc(254*skala),Trunc(125*skala),ttekst[a],Podo);
Mana(a,Podo);
BialoNaC(Trunc(37*skala),Trunc(20*skala),Trunc(22*skala),fMagic,Baza[a].Nazwa,Podo,False);
BialoNaC(Trunc(309*skala),Trunc(417*skala),Trunc(23*skala),fTimes,Baza[a].Param,Podo,True);
BialoNaC(Trunc(27*skala),Trunc(417*skala),Trunc(14*skala),fTimes,'PieterCennik '+WersjaNormalnie,Podo,False);
BialoNaC(Trunc(27*skala),Trunc(430*skala),Trunc(10*skala),fTimes,'PieterSoft  2002-'+rok+', '+web,Podo,False);
aa:=0;
case Baza[a].Kolor of
     kBlue: aa:=2;
     kBlack: aa:=2;
     kRed: aa:=1;
     kGreen: aa:=1;
     kLand: aa:=1;
     kArtifact: aa:=2;
     kMulti: aa:=2;
     end;
BialoNaC(Trunc(37*skala),Trunc((255+aa)*skala),Trunc(18*skala),fTimes,Baza[a].Typ,Podo,False);
Rarity(a,Podo);
OpiszEdycje(a,Podo);
end;

procedure TFBaza.BialoNaC(x,y: Word; siz: Byte; font,s: String; im: TBitmap; dopr: Boolean);
var
bg: TColor;
b: TBitmap;
begin
if s='' then exit;
bg:=im.Canvas.Pixels[x,y];
b:=TBitmap.Create;
b.Assign(Wyraz(bg,clBlack,siz,s,font)^);
if dopr then x:=x-b.Width;
im.Canvas.Draw(x+1,y+1,b);
b.Assign(Wyraz(bg,clWhite,siz,s,font)^);
im.Canvas.Draw(x,y,b);
b.Free;
end;

function TFBaza.ZResJPG(a: Byte): TPoDoBit;
var
str: TResourceStream;
jpg: TJPEGImage;
begin
str:=TResourceStream.Create(hInstance,'P'+IntToStr(a),'JPEGFILE');
jpg:=TJPEGImage.Create;
jpg.LoadFromStream(str);
bimpa.Assign(jpg);
Result:=@bimpa;
str.Free;
jpg.Free;
end;

procedure TFBaza.FormCreate(Sender: TObject);
begin
DoubleBuffered:=True;
SetCurrentDir(deffol);
if not WczytajBaze then
if MessageDlg('Wystpi bd przy otwieraniu pliku bazy. Czy chcesz kontynuowa?',mtError,[mbYes,mbNo],0)<>mrYes then begin
   bezzap:=True;
   FGlowna.Close;
   end;
TypStworow;
FBaza.Left:=aktust.PodPkt.X;
FBaza.Top:=aktust.PodPkt.Y;
skala:=aktust.PodSkala;
rozw:=aktust.PodRozw;
if rozw then BRozw.Tag:=1 else BRozw.Tag:=-1;
RozwDal;
ZresetujSzuk;
FBaza.Visible:=aktust.PodJest;
end;

procedure TFBaza.FormClose(Sender: TObject; var Action: TCloseAction);
begin
FGlowna.PokazBaza.Down:=False;
end;

procedure TFBaza.ToSaMo;
begin
if aknum>0 then CalaZwykla(aknum);
end;

procedure TFBaza.N331Click(Sender: TObject);
begin
skala:=TMenuItem(Sender).Tag/100;
Resajz;
end;

procedure TFBaza.Resajz;
var
a: Integer;
begin
if rozw then a:=250 else a:=0;
OnResize:=nil;
FBaza.ClientHeight:=Trunc(468*skala);
OnResize:=FormResize;
FBaza.ClientWidth:=Trunc(336*skala)+a;
end;

procedure TFBaza.FormResize(Sender: TObject);
begin
Img.Width:=Trunc(skala*336);
Img.Height:=Trunc(skala*468);
Img.Picture.Bitmap.Width:=Img.Width;
Img.Picture.Bitmap.Height:=Img.Height;
BRozw.Top:=Img.Height-18;
BRozw.Left:=Img.Width-48;
ToSaMo;
end;

procedure TFBaza.BRozwClick(Sender: TObject);
begin
BRozw.Tag:=-BRozw.Tag;
rozw:=not rozw;
RozwDal;
end;

procedure TFBaza.RozwDal;
type
TKoPo = TComponent;
const
capt: array[-1..1] of String = ('rozwi','','zwi');
var
i: Integer;
kk: TKoPo;
begin
BRozw.Caption:=capt[BRozw.Tag];
if rozw then Resajz;
for i:=0 to FBaza.ComponentCount-1 do begin
    kk:=FBaza.Components[i];
    if (kk is TControl) and (kk<>Img) and (kk<>BRozw) then (kk as TControl).Visible:=rozw;
    end;
if not rozw then Resajz;
end;

procedure TFBaza.ZresetujSzuk;
var
i: Integer;
begin
itemsc:=il;
for i:=1 to il do itemsy[i]:=i;
vres:=True;
Wypisywanko;
end;

procedure TFBaza.ListBox1Data(Control: TWinControl; Index: Integer;
  var Data: String);
begin
Data:=Baza[itemsy[Index+1]].Nazwa;
end;

procedure TFBaza.Button1Click(Sender: TObject);
var
a,b,i: Integer;
ffnazwa: String;
fftekst: String;
ffrodz: String;
ffpodt: String;
ffmana1, ffmana2: Integer;
s,tt: String;
se: set of Char;
label nast,pona;
begin
se:=[];
if FBysz.ShowModal<>mrOk then exit;
itemsc:=0;
ffnazwa:=LowerCase(FBysz.ENazwa.Text);
fftekst:=FBysz.ETekst.Text;
if FBysz.CzCase.Checked=False then fftekst:=LowerCase(fftekst);
ffrodz:=LowerCase(FBysz.CbRodzaj.Text);
ffpodt:=LowerCase(FBysz.CbPodtyp.Text);
ffmana1:=StrToIntDef(FBysz.EK1.Text,-1);
ffmana2:=StrToIntDef(FBysz.EK2.Text,-1);
vres:=True;
for i:=1 to il do begin
    if ffnazwa<>'' then if Pos(ffnazwa,LowerCase(Baza[i].Nazwa))=0 then goto nast;
    s:=ttekst[i];
    if FBysz.CzCase.Checked=False then s:=LowerCase(s);
    if fftekst<>'' then if Pos(fftekst,s)=0 then goto nast;
    with FBysz do begin
         if not CzU.Checked then if Baza[i].Kolor=kBlue then goto nast;
         if not CzB.Checked then if Baza[i].Kolor=kBlack then goto nast;
         if not CzR.Checked then if Baza[i].Kolor=kRed then goto nast;
         if not CzG.Checked then if Baza[i].Kolor=kGreen then goto nast;
         if not CzW.Checked then if Baza[i].Kolor=kWhite then goto nast;
         if not CzA.Checked then if Baza[i].Kolor=kArtifact then goto nast;
         if not CzL.Checked then if Baza[i].Kolor=kLand then goto nast;
         if not CzM.Checked then if Baza[i].Kolor=kMulti then goto nast;
         end;
    a:=FBysz.cbEdycja.ItemIndex;
    if a>0 then begin
       a:=EdycPtr[a];
       for b:=1 to 30 do begin
           if Baza[i].Edycje[b]=0 then break;
           if Baza[i].Edycje[b]=a then begin
              a:=0;
              break;
              end;
           end;
       if a>0 then goto nast;
       end;

    a:=FBysz.CbRodzaj.ItemIndex;
    if a>0 then begin
       tt:=LowerCase(Baza[i].Typ);
       if Copy(tt,1,10)='legendary ' then Delete(tt,1,10);
       if a=4 then s:='enchant ' else s:=ffrodz;
       if a in [0] then if tt<>ffrodz then goto nast;
       if a in [1,2,3,4,5,6] then begin
          case a of
               2: if (Copy(tt,1,17)<>'artifact creature') and (Copy(tt,1,8)<>'creature') then goto nast;
               3,4,5,6: if Copy(tt,1,Length(s))<>s then goto nast;
               1: if (not(tt='artifact')) and not(Copy(tt,1,10)='artifact ') then goto nast;
               end;
          b:=FBysz.CbPodtyp.ItemIndex;
          if b>0 then begin
             if a in [1,2,3,5,6] then begin
                if Pos('  ',tt)>0 then begin
                   s:=' '+Copy(tt,Pos('  ',tt)+3,Length(tt))+' ';
                   if not ((ffpodt<>'brak') and (Pos(' '+ffpodt+' ',s)>0)) then goto nast;
                end else begin
                    if ffpodt<>'brak' then goto nast;
                end;
                end;
             if (a=4) and (tt<>ffpodt) then goto nast;
             end;
          end;
       end;
    with FBysz do begin
       s:=Baza[i].Param;
       if s<>'' then begin
       a:=StrToIntDef(Copy(s,1,Pos('/',s)-1),0);
       Delete(s,1,Pos('/',s));
       if (StS1.Text<>'') and (a<StrToInt(StS1.Text)) then goto nast;
       if (StS2.Text<>'') and (a>StrToInt(StS2.Text)) then goto nast;
       a:=StrToIntDef(s,0);
       if (StW1.Text<>'') and (a<StrToInt(StW1.Text)) then goto nast;
       if (StW2.Text<>'') and (a>StrToInt(StW2.Text)) then goto nast;
       end;
       end;
    a:=CalyKoszt(Baza[i].Koszt);
    if (ffmana1>-1) and (a<ffmana1) then goto nast;
    if (ffmana2>-1) and (a>ffmana2) then goto nast;
    Inc(itemsc);
    itemsy[itemsc]:=i;
    goto pona;
    nast: vres:=False;
    pona:
    end;
Wypisywanko;
end;

procedure TFBaza.Wypisywanko;
begin
ListBox1.Count:=itemsc;
Zaznacz(0);
IleZnal;
if Visible then ListBox1.SetFocus;
end;

procedure TFBaza.Zaznacz(a: Integer);
begin
ListBox1.ItemIndex:=a;
CalaZwykla(itemsy[a+1]);
end;

procedure TFBaza.Button2Click(Sender: TObject);
begin
if vres then exit;
ZresetujSzuk;
end;

procedure TFBaza.ListBox1DblClick(Sender: TObject);
var
g: Boolean;
a: Integer;
s: String;
begin
a:=ListBox1.ItemIndex;
if (a<0) or not FGlowna.BSzukaj.Enabled then exit;
g:=aktust.Opcje[0];
aktust.Opcje[0]:=True;
s:=ListBox1.Items[ListBox1.ItemIndex];
with FGlowna do begin
     Nazwa.Text:=s;
     BSzukaj.Click;
     end;
aktust.Opcje[0]:=g;
end;

procedure TFBaza.TypStworow;
var
i,j: Integer;
s,t: String;
u: Boolean;
begin
for i:=1 to 6 do begin
    cTyp[i]:=TStringList.Create;
    cTyp[i].Sorted:=True;
    cTyp[i].Duplicates:=dupIgnore;
    end;
for i:=1 to il do begin
    s:=Baza[i].Typ;
    if Copy(s,1,10)='Legendary ' then Delete(s,1,10);
    for j:=1 to 6 do if j<>4 then begin
        u:=False;
        case j of
             1: u:=(Copy(s,1,10)='Artifact ');
             2: u:=((Copy(s,1,10)='Creature ') or (Copy(s,1,19)='Artifact Creature '));
             3: u:=(Copy(s,1,13)='Enchantment ');
             5: u:=(Copy(s,1,9)='Instant ');
             6: u:=(Copy(s,1,9)='Sorcery ');
             end;
        if u then begin
           Delete(s,1,Pos('',s));
           s:=Trim(s);
           while Pos(' ',s)>0 do begin
                 t:=Copy(s,1,Pos(' ',s)-1);
                 Delete(s,1,Pos(' ',s));
                 s:=Trim(s);
                 if (Pos('*',t)=0) and (Pos('(',t)=0) then cTyp[j].Add(t);
                 end;
           if (Pos('*',s)=0) and (Pos('(',t)=0) then cTyp[j].Add(s);
           end;
        end;
    if Copy(s,1,8)='Enchant ' then cTyp[4].Add(s);
    end;

for j:=1 to 6 do begin
    cTyp[j].Sorted:=False;
    if j<>4 then cTyp[j].Insert(0,'brak');
    cTyp[j].Insert(0,'dowolny');
    end;
end;

procedure TFBaza.RozwiZwi1Click(Sender: TObject);
begin
BRozw.Tag:=-BRozw.Tag;
rozw:=not rozw;
RozwDal;
end;

function TFBaza.CalyKoszt(s: String): Byte;
var
i,i2: Integer;
b: ShortInt;
t: String;
begin
Result:=0;
for i:=1 to Length(s) do if s[i]='{' then begin
    t:='';
    for i2:=i+1 to Length(s) do if s[i2]<>'}' then t:=t+s[i2] else break;
    b:=StrToIntDef(t,-1);
    if UpperCase(t)='D' then b:=10;

    if b>0 then Inc(Result,b);
    if (b<0) and (LowerCase(t)<>'x') then Inc(Result);
    end;
end;

procedure TFBaza.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
case Key of
     114: Button1.Click;
     115: Button2.Click;
     end;
end;

procedure TFBaza.BitBtn1Click(Sender: TObject);
var
i: Integer;
mo: TTypWyszu;
begin
if not FGlowna.BSzukaj.Enabled then exit;
staust:=aktust;
if vres then mo:=oWszystko else begin
   SetLength(listawyszu,ListBox1.Count);
   for i:=0 to Length(listawyszu)-1 do listawyszu[i]:=LowerCase(ListBox1.Items[i]);
   mo:=oLista;
   end;
with FGlowna do begin
     for i:=0 to IleSklep-1 do UniSzuk('',i,mo);
     KonczWyszu;
     end;
end;

procedure TFBaza.ListBox1DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
zn: String;
a: ShortInt;
begin
with (Control as TListBox).Canvas do begin
     Pen.Color:=clWindowText;
     if odSelected in State then begin
        Brush.Color:=clBtnFace;
        Font.Color:=clWindowText;
     end else begin
         Brush.Color:=clWindow;
         Font.Color:=clWindowText;
     end;
     TextRect(Rect,Rect.Left+24,Rect.Top,Baza[itemsy[Index+1]].Nazwa);
     a:=Baza[itemsy[Index+1]].Kolor;
     if a<=kMulti then begin
        zn:=tKolL[a];
        Draw(Rect.Left+4,Rect.Top,Symbol(Brush.Color,tKolKDk[a],16,zn)^);
        end;
     end;
end;

procedure TFBaza.FormDestroy(Sender: TObject);
var
i: Byte;
begin
bimpa.Free;
for i:=1 to 6 do cTyp[i].Free;
end;

procedure TFBaza.ListBox1KeyPress(Sender: TObject; var Key: Char);
var
a,i: Integer;
s: String;
begin
if Key=#13 then begin
   ListBox1DblClick(ListBox1);
   Key:=#0;
   exit;
   end;

szuktekst:=szuktekst+LowerCase(Key);
a:=0;
for i:=1 to itemsc do begin
    s:=LowerCase(Baza[itemsy[i]].Nazwa);
    if s>=szuktekst then begin
       a:=i;
       break;
       end;
    end;
if a>0 then Zaznacz(a-1);
Timer1.Enabled:=False;
Timer1.Enabled:=True;
Key:=#0;
end;

procedure TFBaza.Timer1Timer(Sender: TObject);
begin
szuktekst:='';
Timer1.Enabled:=False;
end;

procedure TFBaza.IleZnal;
begin
LZnal.Caption:=Format('Znaleziono %s',[OdmienKarte(itemsc)]);
end;

procedure TFBaza.OpiszEdycje(Numer: Word; Podo: TBitmap);
const
Czcionka = 16;
var
i: Integer;
a: Byte;
s: String;
ar: array of String;
maxl: Integer;
offl: Integer;
offg: Integer;
label nast;
begin
s:='';
maxl:=Trunc(255*skala);
offl:=Trunc(40*skala);
with Podo.Canvas do begin
     Font.Height:=Trunc(Czcionka*skala);
     Font.Name:='Times New Roman';
     SetLength(ar,1);
     for i:=30 downto 1 do begin
         a:=Baza[Numer].Edycje[i];
         if a=0 then goto nast;
         s:=cEdycje(a,1)+', ';
         if TextWidth(s+ar[High(ar)])>maxl then SetLength(ar,Length(ar)+1);
         ar[High(ar)]:=s+ar[High(ar)];
         nast:
         end;
     s:=ar[0];
     if Copy(s,Length(s)-1,2)=', ' then Delete(s,Length(s)-1,2);
     ar[0]:=s;
     for i:=0 to High(ar) do begin
         s:=Trim(ar[i]);
         offg:=Trunc((250-((i+1)*Czcionka))*skala);
         TextOut(offl+maxl-TextWidth(s),offg,s)
         end;
     end;
end;

procedure TFBaza.WydrukKartClick(Sender: TObject);
const
Aspekt = 0.3122;
var
ss: Real;
dal: Boolean;
szerjed,wysjed,i,j: Integer;
label 1;
begin
if FTrwa.Visible then exit;
if aknum<0 then exit;
Application.CreateForm(TFIsh,FIsh);
dal:=(FIsh.ShowModal=mrYes);
FIsh.Free;
if not dal then exit;
//1: s:=InputBox('Podaj ilo kart do wydrukowania:','Wpisz:','');
ss:=skala;
skala:=Printer.PageWidth*Aspekt/336;
szerjed:=Round(skala*336*1.05);
wysjed:=Round(skala*468*1.05);
beee:=TBitmap.Create;
CalaKarta(aknum,beee);
with Printer do begin
     FTrwa.ProgressBar1.Position:=0;
     FTrwa.Show;
     BeginDoc;
     for i:=0 to 2 do for j:=0 to 2 do begin
         FTrwa.ProgressBar1.Position:=((i*3)+j)*100 div 9;
         if Przyciski[i,j] then Canvas.Draw(j*szerjed,i*wysjed,beee);
         end;
     EndDoc;
     FTrwa.ProgressBar1.Position:=100;
     end;
beee.Free;
skala:=ss;
FTrwa.Hide;
end;

procedure TFBaza.D_taliaClick(Sender: TObject);
var
a: SmallInt;
begin
a:=ListBox1.ItemIndex;
if a>=0 then FKombo.DodajSobie(a,Sender=D_sajd);
end;

procedure TFBaza.ListBox1Click(Sender: TObject);
begin
if ListBox1.ItemIndex<0 then exit;
CalaZwykla(itemsy[ListBox1.ItemIndex+1]);
end;

procedure TFBaza.CalaZwykla(a: Word);
begin
beee:=TBitmap.Create;
CalaKarta(a,beee);
Img.Canvas.Draw(0,0,beee);
beee.Free;
end;

end.
