unit Unit5;

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, ShellAPI, Typy;

type
  TFInfo = class(TForm)
    Image1: TImage;
    StatusBar1: TStatusBar;
    GB: TGroupBox;
    Panel1: TPanel;
    Memo1: TMemo;
    Memo2: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
sss='Adres internetowy sklepu:'#13#10+
'%s'#13#10#13#10+
'Kontakt e-mail:'#13#10+
'%s';

var
  FInfo: TFInfo;

implementation

uses Unit1;

{$R *.DFM}

procedure TFInfo.Button1Click(Sender: TObject);
var
s: String;
mn,a: Integer;
begin
a:=TButton(Sender).Tag;
s:=Format(sss,[sklepy[a].Atry.URL,sklepy[a].Atry.Mail]);
mn:=sklepy[a].Atry.Minimalne;
if mn>0 then s:=s+#13#10#13#10'Minimalne zamwienie: '+IntToStr(mn)+' PLN';
MessageDlg(s,mtInformation,[mbOK],0);
end;

procedure TFInfo.Image1Click(Sender: TObject);
begin
ShellExecute(GetDesktopWindow,'open','http://'+web,nil,nil,sw_ShowNormal);
end;

procedure TFInfo.FormCreate(Sender: TObject);
var
i: Integer;
bt: TButton;
begin
Memo1.Lines[0]:='PieterCennik '+WersjaNormalnie;
Memo1.Lines[2]:='PieterSoft  '+rok;
Memo1.Lines[3]:=web;
StatusBar1.SimpleText:='PieterSoft  2002-'+rok+' by PieterEr';
for i:=0 to High(sklepy) do begin
    bt:=TButton.Create(Self);
    bt.Parent:=GB;
    bt.Left:=72;
    bt.Top:=32*i+24;
    bt.Width:=153;
    bt.Height:=25;
    bt.Caption:=NazwaNaKompa(sklepy[i].Atry.NazwaSklepu);
    bt.OnClick:=Button1Click;
    bt.Tag:=i;
    end;
Height:=32*Length(sklepy)+248;
end;

end.
